<template>
  <div class="songList">
    <div class="block menu">
      <div>
        <div class="button" v-bind:class="{ active: isActive('top') }" v-on:click="topDownload()">Top Downloads</div>
        <div class="button" v-bind:class="{ active: isActive('star') }" v-on:click="topRated()">Top Rated</div>
        <div class="button" v-bind:class="{ active: isActive('new') }" v-on:click="newest()">Newest</div>
      </div>
      <div class="center">
        <div><input type="text" class="input" v-model="search" @keyup="searchFilter()" placeholder="Search for songs..." autocomplete="off"/></div>
      </div>
      <div class="right">
        <div class="button"><a href="https://scoresaber.com/">ScoreSaber</a></div>
        <div class="button"><a href="https://discord.gg/f759rpu">Discord</a></div>
        <div class="button"><a href="https://wiki.beatsaver.com">Wiki</a></div>
      </div>
    </div>

    <div v-for="song in songs">
      <song :song="song"></song>
    </div>

    <div class="block more" v-if="songs.length && !search">
      <div class="button" v-on:click="fetchMore()">Show more...</div>
    </div>
  </div>
</template>

<script>
  import _ from 'lodash';
  import Song from './Song.vue';

  require('../css/button.css');
  require('../css/menu.css');

  export default {
    'name': 'Beat',
    'components': {
      Song
    },
    'data': function() {
      return {
        'offset': 0,
        'mode': 'new',
        'songs': [],
        'search': ''
      }
    },
    'created': function() {
      this.$http.get('https://beatsaver.com/api.php?mode=top&off=0')
      .then((res) => {
        this.songs = res.body;
      });

      this.$http.get('https://beatsaver.com/api.php?mode=session')
      .then((res) => {
        console.log(res);
      });
    },
    'methods': {
      'fetch': function(more = false) {
        this.$http.get('https://beatsaver.com/api.php?mode='+ this.mode +'&off='+ this.offset)
        .then((res) => {
          if(more) this.songs = this.songs.concat(res.body);
          else this.songs = res.body;
        });
      },
      'topDownload': function() {
        this.mode = 'top';
        this.offset = 0;
        this.search = '';
        this.fetch();
      },
      'topRated': function() {
        this.mode = 'star';
        this.offset = 0;
        this.search = '';
        this.fetch();
      },
      'newest': function() {
        this.mode = 'new';
        this.offset = 0;
        this.search = '';
        this.fetch();
      },
      'fetchMore': function() {
        this.offset = this.offset + 15;
        this.fetch(true);
      },
      'isActive': function(mode) {
        return this.mode === mode;
      },
      'searchFilter': _.throttle(function() {
        if (!this.search) return this.fetch();
        if (this.search.length < 3) return;
        this.$http.get('https://beatsaver.com/search.php?q=' + this.search)
        .then((res) => {
          this.songs = res.body.hits.hits.map((hit) => hit._source);
        });
      }, 1000)
    }
  }
</script>

<style scoped>

  .songList {
    margin-left:auto;
    margin-right:auto;
    display: flex;
    flex-direction: row;
    flex-wrap: wrap;
    width: 1260px;
  }

  .more {
    margin:50px 0;
    display:flex;
    justify-content:center;
    align-items:center;
  }

  .right {
    margin-left:auto;
  }

  .center {
    flex-grow:1;
    display:flex;justify-content:center;align-items:center;
  }

  textarea:focus,
  input:focus {
    outline: 0;
  }

  input, select, textarea, input::placeholder{
    color: white;
  }

  input.input,
  textarea.input {
    padding: 5px;
    font-size: 16px;
    padding-left: 10px;
    background: rgba(0, 0, 0, 0);
    border: 3px solid white;
    border-radius:50px;
    font-weight: bold;
    margin-top: 4px;
    height: 25px;
    overflow-x: hidden;
    transition: color 0.2s, all 0.2s, box-shadow 0.2s, -webkit-box-shadow 0.2s;
  }

  input:focus {
    background-color:white;
    color:black;
    border: 6px solid white;
  }

  ::-webkit-input-placeholder {
   text-align: center;
}

:-moz-placeholder { /* Firefox 18- */
   text-align: center;
}

::-moz-placeholder {  /* Firefox 19+ */
   text-align: center;
}

:-ms-input-placeholder {
   text-align: center;
}

</style>
